require File.expand_path(File.dirname(__FILE__) + "/../../../spec_helper")

describe VidyoIo::Util::Token do
  describe "self.generate" do
    around do |example|
      Timecop.freeze(Time.parse("2016-12-05 18:22:22 +0100")) do
        example.run
      end
    end

    it 'generates a token to last one hour' do
      token = 'cHJvdmlzaW9uAHVzZXIxQGludGVncmF0aW9uX2FwcGxpY2F0aW9uX2lkADYzNjQ4MTgxMzQyAABlMjQ1ZjRjZjAyMjhkNTA0YjA4ZGRiMjQ4MDc4NWY0NWVjZmViN2Y4ZWViZWY4MGE5ZjVlYjdiOTczZWU0OGUxYzFkOGE3ZmM5ZmJjMTQ4M2QxNzRhNTFkMzMxMDY4MjQ='
      expect(VidyoIo::Util::Token.generate(ttl: 3600)).to eq(token)
    end

    it 'generates a token to last one hour with an username' do
      token = 'cHJvdmlzaW9uAHRlc3RfdXNlckBpbnRlZ3JhdGlvbl9hcHBsaWNhdGlvbl9pZAA2MzY0ODE4MTM0MgAAZTJiNGY5YzY5NzEwMWU0OWEyOThjYmViMWVmMDliMGRjNDVlYTg0OTdlYzAwMjcxYWE1NDI2MjliZWMxZDEzNmE3MDA2YzBlODNiM2EzMDAzM2NiM2EwZTBjNmRhNDRm'
      expect(VidyoIo::Util::Token.generate(ttl: 3600, username: 'test_user')).to eq(token)
    end
  end
end
